﻿using System.Collections.ObjectModel;

namespace XamDataTreeHideNodeCase
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> Data { get; set; }

        public ViewModel()
        {
            Data = new ObservableCollection<SampleData>();

            for(int i=0; i<4; i++)
            {
                Data.Add(new SampleData()
                {
                    Label = "Parent Node " + i.ToString()
                });
            }

            Data[0].FirstChildren[0].SecondChildren[1].IsVisible = false;
            Data[1].FirstChildren[1].IsVisible = false;
            Data[2].IsVisible = false;
        }
    }

    public class VisibilityHelper
    {
        public bool IsVisible { get; set; }

        public VisibilityHelper()
        {
            IsVisible = true;
        }
    }

    public class SampleData : VisibilityHelper
    {
        public string Label { get; set; }
        public ObservableCollection<ChildData1> FirstChildren { get; set; }

        public SampleData()
        {
            FirstChildren = new ObservableCollection<ChildData1>();

            for(int i=0; i<3; i++)
            {
                FirstChildren.Add(new ChildData1()
                {
                    Child1Label = "Child " + i.ToString(),
                    IsExpanded = true
                });
            }
        }
    }

    public class ChildData1 : VisibilityHelper
    {
        public string Child1Label { get; set; }

        public bool IsExpanded { get; set; }
        public ObservableCollection<ChildData2> SecondChildren { get; set; }

        public ChildData1()
        {
            SecondChildren = new ObservableCollection<ChildData2>();
            for(int i=0; i<3; i++)
            {
                SecondChildren.Add(new ChildData2()
                {
                    Child2Label = "Second Child " + i.ToString(),
                    IsExpanded = true
                });
            }
        }
    }
    
    public class ChildData2 : VisibilityHelper
    {
        public string Child2Label { get; set; }
        public bool IsExpanded { get; set; }
    }
}
